using System;
using System.Collections.Generic;
using System.Text;

using gudusoft.gsqlparser;
using gudusoft.gsqlparser.Units;


namespace visitexpression
{
    class visitexpression
    {
        static void Main(string[] args)
        {
            TGSqlParser sqlparser = new TGSqlParser(TDbVendor.DbVOracle);
            sqlparser.SqlText.Text = "select f1,fx(p1,t1.p2),sum(t1.x) from t1 where t1.a=10.2 and c='k' and b in (2,4,5) or h in (select f1t2 from t2) having max(x) > 6 ";

            Console.WriteLine("Processing..");

            int i = sqlparser.Parse();
            if (i == 0)
            {
               visitbinaryexprtree(sqlparser.SqlStatements[0].WhereClause);
            }
            else
                Console.WriteLine(sqlparser.ErrorMessages);
        }

        public static void visitbinaryexprtree(TLzCustomExpression pExpr)
        {
            Console.WriteLine("pre-order:");
            pExpr.PreOrderTraverse(treenodevisitor);
            Console.WriteLine("in-order:");
            pExpr.InOrderTraverse(treenodevisitor);
            Console.WriteLine("post-order:");
            pExpr.PostOrderTraverse(treenodevisitor);

        }

        public static Boolean treenodevisitor(TLz_Node pnode, Boolean pIsLeafNode)
        {
            TLzCustomExpression lcexpr;
            if (pIsLeafNode)
            {
                Console.WriteLine(pnode.AsText);
            }
            else
            {
                lcexpr = (TLzCustomExpression)pnode;
                if (lcexpr.oper == TLzOpType.Expr_Parenthesis)
                {
                    Console.WriteLine("()");
                }
                else if (lcexpr.opname != null)
                {
                    Console.WriteLine(lcexpr.opname.AsText);
                }
            }
            return true;
        }

    }
}
